<template>
  <div class="screen" @click="setFocus" ref="screen">
    <p v-for="(line, i) in commandHistory" :key="i">
      <span class="path" v-if="line.path">{{ path }}</span>
      <span>{{ line.cmd }}</span>
    </p>
    <Input ref="input" :path="path" :history="commandHistory" />
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue, Watch } from "vue-property-decorator";
import Input from "./Input.vue";

@Component({
  components: {
    Input,
  },
})
export default class Terminal extends Vue {
  path: string = "[guest@SA-server ~]#";
  commandHistory: Object[] = [];
  $refs!: {
    screen: HTMLElement;
    input: Input;
  };
  // @Prop() private msg!: string;
  @Watch("commandHistory", { immediate: true, deep: true })
  onCmdHsChange() {
    setTimeout(() => {
      this.scrollDown();
    }, 0);
  }

  scrollDown() {
    const screen = this.$refs.screen;
    if (screen) {
      screen.scrollTop = screen.scrollHeight;
    }
  }

  setFocus() {
    this.$refs.input.setFocus();
    console.log(this.$refs);
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="scss">
.screen {
  overflow-y: auto;
  overflow-x: hidden;
  height: calc(100% - 14px);
  padding: 10px;

  p {
    margin-top: 0;
    white-space: pre;
  }
}
.path {
  width: 200px;
  display: inline-block;
}
</style>
